<?php
require_once "config.php";

function connectDB($conncetionString, $username, $password)
{ 
  try
  {
	 $dblink = new PDO($conncetionString,
                       $username,
                       $password, 
                       array(PDO::MYSQL_ATTR_INIT_COMMAND => "SET NAMES utf8")
                      );
	 return $dblink;
  }
  catch (PDOException $e)
  {
	 print("Error connecting to DATABASE");
	 return false;
  }
}

function login()
{
    global $dblink; // connessione al database
    
    // Inizia una nuova SESSIONE o resuma la sessione in corso
    if(session_status() == PHP_SESSION_NONE) session_start();

    //Apre la connessione al DATABASE    
    if(empty($dblink)) $dblink = connectDB(DB_CONNECTION_STRING, DB_USERNAME, DB_PASSWORD);
    if($dblink === false) 
    {
        header ("location:".CONFIG_BASE_URL.CONFIG_LOGIN_PAGE.'?error=DB');
        return false;
    }

    // Verifica se l'utente vuole fare il LOGOUT 
    if (isset($_GET['logout']) and $_GET['logout']=="yes")  
    {
        // distrugge l'eventuale sessione attiva
        if (isset($_SESSION['username']))
        {
            // Cancella tutte le variabili di sessione.
            //session_unset();
            // Distrugge la sessione.
            session_destroy();
        }
        header ("location:".CONFIG_BASE_URL.CONFIG_LOGIN_PAGE);
        return false;
    } // FINE LOGOUT
    elseif(isset($_SESSION['username'])) // ho già fatto il login
        return true;
    elseif (isset($_POST['username']) and isset($_POST['password']))     
    {   // Login per la prima volta
        if (user_is_registered($_POST['username'], $_POST['password']))
        {
            // Recupera tutte le info dell'utente, e le memorizza in $_SESSION
            $sql="select * from utenti where username = ?";
            $st=$dblink->prepare($sql);
            $success=$st->execute(array($_POST['username']));
            while($row=$st->fetch())
            {
                $_SESSION['username']=$row['username'];
                $_SESSION['nome']=$row['nome'];
                $_SESSION['cognome']=$row['cognome'];
            }
        }
        // Utente non registrato: Reindirizza browser a pagina del login
        else header ("location:".CONFIG_BASE_URL.CONFIG_LOGIN_PAGE."?error=1");
    }
    else header ("location:".CONFIG_BASE_URL.CONFIG_LOGIN_PAGE);
}// fine login()


function user_is_registered($username, $password)
{
  global $dblink;
  if(empty($dblink)) $dblink = connectDB(DB_CONNECTION_STRING , DB_USERNAME, DB_PASSWORD);

  $sql="SELECT count(*) FROM utenti WHERE username = ? AND password = MD5(?)";

  $st = $dblink->prepare($sql);
  $success = $st->execute(array($username, $password)) or die("ERRORE IN Sql: $sql");

  $quanti = $st->fetchColumn();
  if($quanti > 0) return true;
               	  else return false;
}
?>